//====----------------------- --- --   -      -
// MULTIUSER NETWORK MANAGEMENT
// TCP/IP and UDP support.
// 2000-2002, Vander Nunes
//======----------------------------- --- --   -      -


#include "net.h"
#include <stdio.h>


// ------------------------------------------------------------------------
// A Basic, still smart window creation function.
// ------------------------------------------------------------------------
HWND NetMakeWindow(const char *szTitle, DWORD dwRefCount, int iWidth, int iHeight, DWORD dwFlags, WNDPROC hWndProc)
{

  if (dwRefCount == 1)
  {
    // our window class
    WNDCLASS wndWc;

    // ---------------------------------------------------------
    // fill window class members
    // ---------------------------------------------------------
    wndWc.style = CS_OWNDC;
    wndWc.lpfnWndProc = (WNDPROC)hWndProc;
    wndWc.cbClsExtra = 0;
    wndWc.cbWndExtra = 0;
    wndWc.hInstance = GetModuleHandle(NULL);
    wndWc.hIcon = NULL;
    wndWc.hCursor = LoadCursor(0, IDC_ARROW);
    wndWc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    wndWc.lpszMenuName = NULL;
    wndWc.lpszClassName = szTitle;

    // register class
    //if (!RegisterClass(&wndWc)) return false;

    // ### was creating problems with
    // CNetClient and CNetServer,
    // like, the user deleted the first instance of NetClient,
    // then newed[] it again... the reference count was 1 again then,
    // but the class continued registered. To solve this,
    // those classes must delete the window class when RefCount reachs zero.
    // For now, this quick hack will do =)
    RegisterClass(&wndWc);
  }
  // ---------------------------------------------------------

  // get actual screen resolution
  int iSw = (WORD)GetSystemMetrics(SM_CXSCREEN);       // width
  int iSh = (WORD)GetSystemMetrics(SM_CYSCREEN);       // height

  // make a rectangle on the center of the screen
  RECT rc = { (iSw - iWidth)/2, (iSh - iHeight)/2, iWidth, iHeight };

  // create the window. the spaces on the window title
  // are just to make sure this will be visible when the region
  // is active. just run the app and you'll understand. =)
  HWND hWnd = CreateWindow(szTitle, szTitle,
                           WS_OVERLAPPEDWINDOW,
                           rc.left,rc.top, iWidth,iHeight,
                           NULL, NULL, GetModuleHandle(NULL), NULL);

  // return result
  return hWnd;
}
